hdu 5918 Sequence I

给两个数组a , b,并给一个间隔值p。问在间隔值p下b在中有多少个匹配。

比如a数组为1 2 2 4 3,b数组为1 2 3,那么在间隔值为2的情况下有一个匹配。

把a数组中可以作为开头的所有间隔数字比如2可以开头的数字是1或者2,3可以开头的数字是1、2、3取出来。

然后做p次kmp即可。

//#define test
#include<bits/stdc++.h>
using namespace std;
const int Nmax=2e6+7;
int f[Nmax];
int flag[Nmax];
inline void init(int *s,int m)
{
    f[0]=f[1]=0;
    for(int i=1; i<m; i++)
    {
        int j=f[i];

        while(j && s[i]!=s[j])
            j=f[j];

        f[i+1] = s[i] == s[j] ? j + 1 : 0;
    }
}
inline int get(int *s,int *t,int m,int n)
{
    int ans=0;

    for(int i=0,j=0; i<n; ++i)
    {
        while(j && t[i]!=s[j])
            j=f[j];

        j+=(t[i]==s[j]);

        if(j==m)
        {
            //printf("\n now: %d\n",i-m+1);
            ans++;
            j=f[j];
        }
    }

    return ans;
}
int s[Nmax],t[Nmax];
int m,n;
int p;
int a[Nmax],b[Nmax];
int main()
{
#ifdef test
#endif
    int tt;
    //freopen("h.in","r",stdin);
    scanf("%d",&tt);
    for(int cases=1;cases<=tt;cases++)
    {
        printf("Case #%d: ",cases);
        scanf("%d%d%d",&m,&n,&p);
        for(int i=1;i<=m;i++)
            scanf("%d",&a[i]);
        for(int i=1;i<=n;i++)
            scanf("%d",&b[i]);
        for(int i=0;i<n;i++)
            t[i]=b[i+1];
            //printf("%s\n",t);

        //t[n]=‘\0‘;
        int ans=0;
        for(int i=0;i<=m+1;i++)
            flag[i]=0;
        init(t,n);
        //if(m<p)
        //{
            //if(n==1)
            //{
                //for(int i=1;i<=m;i++)
                    //if(a[i]==b[1])
                        //ans++;
            //}

            //printf("%lld\n",ans);
            //continue;
        //}
        int flagnow=0;
        for(int now=1;now+(n-1)*p<=m;now++)
        {
            int ttt=0;
            for(int i=now;i<=m;i+=p)
            {
                if(flag[i])
                {
                    flagnow=1;
                    break;
                }
                s[ttt++]=a[i];
                flag[i]=1;
            }
            if(!ttt || flagnow)
                break;
            if(ttt<n)
                break;
            //s[ttt]=‘\0‘;
            //printf("%s",s);
            //init(ttt);
            //printf("g:%d\n",get(t,s,n,ttt));
            ans+=get(t,s,n,ttt);
        }
        printf("%d\n",ans);
    }
    return 0;
}

原文地址:https://www.cnblogs.com/LMissher/p/9673944.html

时间: 2024-10-20 00:41:27

hdu 5918 Sequence I的相关文章

HDU 5918 Sequence I KMP

Sequence I Problem Description Mr. Frog has two sequences a1,a2,?,an and b1,b2,?,bm and a number p. He wants to know the number of positions q such that sequence b1,b2,?,bmis exactly the sequence aq,aq+p,aq+2p,?,aq+(m−1)p where q+(m−1)p≤n and q≥1. In

HDU 5918 Sequence I (KMP)

Sequence I Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 2330    Accepted Submission(s): 874 Problem Description Mr. Frog has two sequences a1,a2,?,an and b1,b2,?,bm and a number p. He wants t

HDU 3397 Sequence operation(线段树)

HDU 3397 Sequence operation 题目链接 题意:给定一个01序列,有5种操作 0 a b [a.b]区间置为0 1 a b [a,b]区间置为1 2 a b [a,b]区间0变成1,1变成0 3 a b 查询[a,b]区间1的个数 4 a b 查询[a,b]区间连续1最长的长度 思路:线段树线段合并.须要两个延迟标记一个置为01,一个翻转,然后因为4操作,须要记录左边最长0.1.右边最长0.1,区间最长0.1,然后区间合并去搞就可以 代码: #include <cstdi

hdu 5667 Sequence 矩阵快速幂

题目链接:hdu 5667 Sequence 思路:因为fn均为a的幂,所以: 这样我们就可以利用快速幂来计算了 注意: 矩阵要定义为long long,不仅仅因为会爆,还会无限超时 要对a%p==0特判,以为可能出现指数%(p-1)==0的情况,那么在快速幂的时候返回的结果就是1而不是0了 /************************************************************** Problem:hdu 5667 User: youmi Language:

HDU 3998 Sequence(经典问题,最长上升子序列)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3998 解题报告:求一个数列的最长上升子序列,并求像这样长的不相交的子序列最多有多少个. 我用的是最简单的方法,就是每次求最长上升子序列,然后每次将求得的子序列从数列里面删掉,然后再对剩下的数列求最长上升子序列,如果求得的子序列的长度比第一次求得的长度小的话,就退出.不过我这题卡了很久,原因就是因为用这种方法求的过程中,用到了很多变量,但是没有注意每一步求最长上升子序列的时候都要进行初始化,哎. Vi

hdu 5147 Sequence II(树状数组)

题目链接:hdu 5147 Sequence II 预处理每个位置作为b和c可以组成的对数,然后枚举b的位置计算. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; typedef long long ll; const int maxn = 50005; int N, arr[maxn], fenw[maxn], lef[maxn], rig[maxn]; #d

hdu 3379 Sequence operation(成段更新,区间合并)

http://acm.hdu.edu.cn/showproblem.php?pid=3397 线段树很好的题.涉及到的知识点:lazy操作处理异或操作和置01,区间合并. 有五种操作: 0 a b 将[a,b]变为0 1 a b 将[a,b]变为1 2 a b 将[a,b]取反 3 a b 输出[a,b]的1的个数 4 a b 输出[a,b]内最长的连续1的个数 对区间的操作与poj 3225类似.置01与取反是互斥的,一段区间上只能有一个标记,discuss里面也说了取反的时候若递归到区间全为

【线段树】HDU 3397 Sequence operation 区间合并

操作 Change operations: 0 a b change all characters into '0's in [a , b] 1 a b change all characters into '1's in [a , b] 2 a b change all '0's into '1's and change all '1's into '0's in [a, b] Output operations: 3 a b output the number of '1's in [a,

HDU 3397 Sequence operation 线段树

线段树大杂烩~ 各种操作都有,细心点不难1A #include <iostream> #include <cstring> #include <cstdio> #include <algorithm> using namespace std; #define lson rt<<1,l,mid #define rson rt<<1|1,mid + 1,r const int maxn = 1e5 + 10; int lmax[maxn